<?php

namespace Drupal\cmlmigrations\Controller;

use Drupal\Core\Controller\ControllerBase;

/**
 * Controller routines for page example routes.
 */
class FixVariation extends ControllerBase {

  /**
   * Find variations.
   */
  public static function findVariations($id1c) {
    $variations = [];

    if ($id1c) {
      $query = \Drupal::database()->select('migrate_map_cml_product_variation', 'variation_migration');
      $query->fields('variation_migration', ['destid1', 'sourceid1']);
      $query->condition('sourceid1', "%$id1c%", 'LIKE');
      $res = $query->execute();

      if ($res) {
        foreach ($res as $key => $value) {
          $variations[] = [
            'src' => $value->sourceid1,
            'target_id' => $value->destid1,
          ];
        }
      }
    }
    return $variations;
  }

  /**
   * Fix on Save.
   */
  public static function fixOnSave($product) {

  }

  /**
   * Fix On Insert.
   */
  public static function fixOnInsert($product) {
    $variations = $product->variations->getValue();
    $vids = self::varIds($variations);
    if ($vids && $product->id()) {
      self::fix($vids, $node);
    }
  }

  /**
   * VAriation Ids.
   */
  public static function varIds($variations) {
    $vids = FALSE;
    if (!empty($variations)) {
      $vids = [];
      foreach ($variations as $variation) {
        $vids[] = (int) $variation['target_id'];
      }
    }
    return $vids;
  }

  /**
   * Fix.
   */
  public static function fix($vids, $node) {
    foreach ($vids as $vid) {
      $storage = \Drupal::entityManager()->getStorage('commerce_product_variation');
      $variation = $storage->load($vid);
      $title = $variation->title->value;
      $product_id = $variation->product_id->getValue();
      if (!$title || empty($product_id)) {
        $pid = $variation->get('product_id');
        $pid->setValue($node);
        $variation->save();
      }
    }
  }

}
